import { reactive as A, defineComponent as Vl, getCurrentInstance as Pl, ref as b, computed as O, onMounted as Bl, watchEffect as xl, toRefs as Sl, resolveComponent as g, resolveDirective as He, openBlock as p, createBlock as f, normalizeStyle as Hl, unref as L, withCtx as n, createVNode as r, withDirectives as j, createElementVNode as se, renderSlot as H, withKeys as Ae, createElementBlock as M, Fragment as U, renderList as Y, mergeProps as B, createCommentVNode as $, vShow as Al, createTextVNode as N, toDisplayString as de, createSlots as ke, resolveDynamicComponent as kl, normalizeProps as Ml, guardReactiveProps as Ul } from "vue";
import { ElNotification as Rl, ElMessage as Me, ElMessageBox as _e } from "element-plus";
import { useRoute as Nl } from "vue-router";
const Q = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function zl(u = { debug: !1 }) {
  const i = A({
    hooks: {}
  });
  return Object.keys(u).forEach((t) => {
    t !== "debug" && (i.hooks[t] = u[t]);
  }), {
    hookHandler: (t, x) => {
      let E = !1;
      try {
        u.debug && (console.group("DeBug\uFF1A", t), console.table(x.Data), console.groupEnd()), E = i.hooks[t](x);
      } catch {
        E = !0;
      }
      return E;
    }
  };
}
const ne = (u, i = "success") => {
  Rl({
    title: u,
    type: i,
    offset: 70,
    duration: 2500
  });
};
function R(u) {
  let i;
  try {
    i = Array.isArray(u) ? [] : {}, u === null && (i = null);
  } catch {
    i = {};
  }
  for (const m in u)
    typeof u[m] == "object" ? i[m] = R(u[m]) : i[m] = u[m];
  return i;
}
function pe(u, i) {
  let m = R(u);
  for (var t in i)
    m.hasOwnProperty(t) && typeof i[t] == "object" ? m[t] = pe(m[t], i[t]) : m[t] = i[t];
  return m;
}
function Ol(u, i) {
  let m = {}, t = Object.getOwnPropertyNames(u), x = Object.getOwnPropertyNames(i);
  return t.length === x.length && t.forEach((E) => {
    u[E] !== i[E] && (m[E] = i[E]);
  }), m;
}
const $l = {
  debug: !1,
  IssearchForm: !0,
  labelWidth: 120,
  expand: !0,
  expandColumn: 4,
  menuWidth: 310,
  menuAlign: "left",
  dialogWidth: 800,
  editFooterButton: !0,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  hideOnSinglePage: !1,
  queryAfterMount: !1,
  openMultipleSelection: !1,
  openIndex: !0,
  destroyOnClosModal: !0,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let w = A({});
function I(...u) {
  w.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...u);
}
const Ue = (u) => {
  w = pe($l, u);
};
Ue({});
const Il = /* @__PURE__ */ N(" \u65B0\u589E "), Kl = /* @__PURE__ */ N(" \u6279\u91CF\u5220\u9664 "), Tl = { class: "quick-search-area" }, ql = { style: { display: "flex", "justify-content": "flex-end" } }, Wl = /* @__PURE__ */ N("\u53D6\u6D88"), Ll = /* @__PURE__ */ N("\u91CD\u7F6E"), jl = /* @__PURE__ */ N("\u63D0\u4EA4"), Ql = /* @__PURE__ */ Vl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    queryAfterMount: { type: Boolean, default: () => w.queryAfterMount },
    IssearchForm: { type: Boolean, default: () => w.IssearchForm },
    openMultipleSelection: { type: Boolean, default: () => w.openMultipleSelection },
    openIndex: { type: Boolean, default: () => w.openIndex },
    expand: { type: Boolean, default: () => w.expand },
    expandColumn: { default: () => w.expandColumn },
    PaginationLayout: { default: () => w.PaginationLayout },
    hideOnSinglePage: { type: Boolean, default: () => w.hideOnSinglePage },
    fullscreen: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => w.destroyOnClosModal },
    dialogWidth: { default: () => w.dialogWidth },
    closeOnPressEscape: { type: Boolean },
    editFooterButton: { type: Boolean, default: () => w.editFooterButton },
    permission: { default: () => w.permissions }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(u, { expose: i, emit: m }) {
    const t = u;
    I("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", w), I("\u3010Props\u53C2\u6570\u3011", t);
    const x = Pl(), E = Nl(), k = b(), ce = b(), Ce = b(), ie = b(), J = b("add"), K = b(!1), Z = b(!1), z = b(!1), Re = b(t.editFooterButton), v = A({ ...pe(w, t.source.options) }), { hookHandler: T } = zl(t.hooks);
    let q = O(() => v.CrudRequest);
    const D = b({ filter: {}, editor: {}, column: {} }), Ne = b(), fe = b(), Ee = b(), ve = b(), De = b(), y = b({}), ze = b({}), h = b({}), be = b({}), ee = b([]), Oe = b([]), V = A({
      current: v.Pagination.current,
      pageSize: v.Pagination.pageSize,
      total: v.Pagination.total
    }), G = b(0), ge = b(0), me = b(0), le = b(0);
    if ((() => {
      const { filter: l, editor: a, column: o, columns: c } = t.source;
      let F = {};
      l.forEach((C) => {
        c[C].searchDefaultValue !== void 0 ? F[C] = c[C].searchDefaultValue : F[C] = void 0, D.value.filter[C] = c[C];
      }), ve.value = R(F), y.value = R(ve.value);
      let X = {};
      a.forEach((C) => {
        c[C].addDefaultValue !== void 0 ? X[C] = c[C].addDefaultValue : X[C] = void 0, D.value.editor[C] = c[C];
      }), De.value = R(X), o.forEach((C) => {
        D.value.column[C] = c[C];
      }), Ne.value = c;
    })(), E.params.data) {
      I("\u8DEF\u7531\u4F20\u53C2\uFF1A", E.params.data);
      let l = E.params.data, a = JSON.parse(l);
      y.value = pe(y.value, a), I("searchModel", y);
    }
    const $e = O(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker"];
      return t.source.filter.forEach((o) => {
        a.includes(D.value.filter[o].type) && (l[o] = D.value.filter[o]);
      }), l;
    }), Ie = O(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker", "el-cascader", "el-upload"];
      return t.source.editor.forEach((o) => {
        a.includes(D.value.editor[o].type) && W(D.value.editor[o], "visible") && (l[o] = D.value.editor[o]);
      }), l;
    }), Ke = O(() => ({ ...t.wrapperStyle })), Te = O(() => (V.current - 1) * V.pageSize + 1), qe = O(() => {
      const l = b(0);
      return console.log("\u5F53\u524D\u8868\u683C\u72B6\u6001", v.IssearchForm), t.tableHeight ? l.value = t.tableHeight : v.IssearchForm ? (console.log("\u5C55\u5F00"), l.value = ge.value) : (console.log("\u6298\u53E0"), l.value = me.value), console.log("\u8868\u683C\u9AD8\u5EA6", l.value), l.value;
    }), we = O(() => t.fullscreen ? le.value - 50 : le.value > 250 ? le.value - G.value * 0.3 : 250);
    Bl(() => {
      G.value = document.documentElement.clientHeight, k.value.style.display = "block", ge.value = G.value - 50 - 20 - 40 - 56 - ce.value.clientHeight - k.value.clientHeight, k.value.style.display = "none", me.value = G.value - 50 - 20 - 40 - 56 - ce.value.clientHeight, le.value = G.value - 54 - 62, t.queryAfterMount && P(), t.watchData && t.watchData.forEach((l) => {
        xl(() => {
          h.value[l.id] && (I("\u76D1\u542C\u7684id\u6570\u636E", h.value[l.id]), l.data.forEach((a) => {
            a.data[l.id] = h.value[l.id], I("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", a), ll(a);
          }));
        });
      }), I("onMounted", _), I("Hight", { clientHeight: G, OpenSearchFormtableMaxHeight: ge, CloseSearchFormtableMaxHeight: me, EditFormMaxHeight: le });
    });
    const he = (l) => {
      let a = {};
      return t.rowKey && (a[t.rowKey] = l[t.rowKey]), t.rowKeys && t.rowKeys.forEach((o) => {
        a[o] = l[o];
      }), a;
    }, te = (l) => l.formProps && l.formProps.type ? l.range ? l.formProps.type + "range" : l.formProps.type : "date", W = (l, a) => {
      if (a === "disabled")
        return typeof l.disabled == "function" ? l.disabled(_, J.value) : !1;
      if (a === "visible")
        return typeof l.visible == "function" ? l.visible(_, J.value) : !0;
    }, We = (l, a, o, c) => {
      m("cell-click", { row: l, column: a, cell: o, event: c });
    }, Le = (l, a, o, c) => {
      a.label && navigator.clipboard.writeText(o.innerText).then(() => {
        Me.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, je = (l, a, o) => {
      m("row-contextmenu", { row: l, column: a, event: o }, _);
    }, Qe = (l) => {
      ee.value = l;
    }, Je = (l) => {
      let a = { ...l };
      return Object.keys(a).forEach((o) => {
        typeof a[o] == "function" && (a[o] = a[o].bind(this, _));
      }), a;
    }, Ge = (l, a) => {
      let o = { ...l };
      return Object.keys(o).forEach((c) => {
        typeof o[c] == "function" && (o[c] = o[c].call(this, _, a));
      }), o;
    }, Xe = (l) => {
      V.pageSize = l, P();
    }, Ye = (l) => {
      V.current = l, V.current != null && P();
    }, Ze = (l, a, o) => {
      if (a.type === "el-select") {
        const c = a.formProps.options.findIndex((F) => F.value == l.row[o]);
        return c === -1 ? l.row[o] : a.formProps.options[c].label;
      } else
        return l.row[o];
    }, el = () => {
      ue.value.length && ue.value.forEach((l) => {
        D.value.editor[l].formProps.fileList = [];
      });
    }, ue = O(() => {
      let l = [];
      for (const a in D.value.editor)
        if (Object.prototype.hasOwnProperty.call(D.value.editor, a)) {
          const o = D.value.editor[a];
          o.type === "el-upload" && o.formProps.hasOwnProperty("listType") && o.formProps.listType === "picture-card" && l.push(a);
        }
      return l;
    }), ll = (l) => {
      q.value({ url: l.url, name: l.name, data: l.data }).then((a) => {
        D.value.editor[l.key].formProps.options = a.data.map((o) => {
          if (typeof l.label == "string")
            return {
              value: o[l.value],
              label: o[l.label]
            };
          if (typeof l.label == "object")
            return {
              value: o[l.value],
              label: o[l.label[0]] + "--" + o[l.label[1]]
            };
        });
      });
    }, P = () => {
      Z.value = !0;
      const l = A({
        ...y.value
      });
      for (const a in l)
        Object.prototype.hasOwnProperty.call(l, a) && typeof l[a] == "string" && (l[a] = l[a].trim(), l[a] === "" && (l[a] = void 0));
      !T(Q.beforeQueryHandler, { CrudState: _, Data: l }) || q.value({
        url: t.url,
        name: v.apiName.query,
        data: {
          pagenum: V.current,
          pagesize: V.pageSize,
          ...l
        }
      }).then((a) => {
        const { data: o, page: c } = a;
        setTimeout(() => {
          al(o, l), V.total = c.total, Z.value = !1;
        }, 50);
      }).catch(() => {
        Z.value = !1;
      });
    }, al = (l, a) => {
      Object.keys(a).filter((c) => a[c] != null).length == 0 && (Ee.value = l), Ee.value = R(l), T(Q.afterQueryHandler, { CrudState: _, Data: l }) && (fe.value = R(l));
    }, ol = () => {
      y.value = R(ve.value), P();
    }, nl = (l) => {
      !l || (l.resetFields(), ue.value.length && ue.value.forEach((a) => {
        const o = a + "UploadRef";
        (x == null ? void 0 : x.refs[o])[0].clearFiles();
      }));
    }, tl = () => {
      h.value = R(De.value);
      const l = A({ ...h.value });
      !T(Q.beforeAddHandler, { CrudState: _, Data: l }) || (J.value = "add", K.value = !0);
    }, ul = (l) => {
      const a = A({
        ...l
      });
      !T(Q.beforeEditHandler, { CrudState: _, Data: a }) || (Object.keys(a).forEach((o) => {
        h.value[o] = a[o], be.value[o] = a[o];
      }), J.value = "edit", K.value = !0);
    }, re = async (l) => {
      !l || await l.validate((a) => {
        if (a) {
          const o = A({
            ...h.value
          });
          if (!T(Q.beforeSubmitHandler, { CrudState: _, Data: o }))
            return;
          _.Mode === "add" ? rl(o) : sl(o);
        }
      });
    }, rl = (l) => {
      z.value = !0;
      let a = l;
      l.FormData instanceof FormData && (a = l.FormData), q.value({ url: t.url, name: v.apiName.add, data: a }).then(() => {
        K.value = !1, ne("\u65B0\u589E\u6210\u529F"), P(), z.value = !1;
      }).catch(() => {
        z.value = !1;
      });
    }, sl = (l) => {
      z.value = !0;
      let a = l;
      if (l.FormData instanceof FormData)
        a = l.FormData;
      else {
        const o = Ol(be.value, a);
        if (JSON.stringify(o) === "{}")
          return z.value = !1, Me({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        a = {
          ...he(l),
          ...o
        };
      }
      q.value({ url: t.url, name: v.apiName.edit, data: a }).then(() => {
        K.value = !1, ne("\u4FEE\u6539\u6210\u529F"), P(), z.value = !1;
      }).catch(() => {
        z.value = !1;
      });
    }, dl = (l) => {
      _e.confirm(`\u786E\u5B9A\u8981 \u201C${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l),
          deleteFlag: l.deleteFlag == 0 ? 1 : 0
        });
        !T(Q.beforedisabledHandler, { CrudState: _, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.deleteFlag,
          data: a
        }).then(() => {
          ne(`\u6570\u636E${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), P();
        });
      }).catch(() => {
      });
    }, pl = (l) => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l)
        });
        !T(Q.beforeDeteleHandler, { CrudState: _, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.delete,
          data: a
        }).then(() => {
          ne("\u5220\u9664\u6210\u529F"), P();
        });
      }).catch(() => {
      });
    }, cl = () => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = ee.value.map((a) => a[t.rowKey]);
        q.value({
          url: t.url,
          name: v.apiName.remove,
          data: { [t.rowKey]: l, selection: ee.value }
        }).then(() => {
          ne("\u6279\u91CF\u5220\u9664\u6210\u529F"), ee.value = [], Ce.value.clearSelection(), P();
        });
      }).catch(() => {
      });
    }, _ = A({
      ElementArrs: D,
      tableData: fe,
      searchModel: y,
      searchFormValue: ze,
      editModel: h,
      editFormValue: be,
      uploadFiles: Oe,
      tableLoading: Z,
      Pagination: V,
      Mode: J,
      queryRecord: P
    });
    return i({
      ...Sl(_)
    }), (l, a) => {
      const o = g("el-input"), c = g("el-form-item"), F = g("el-col"), X = g("el-input-number"), C = g("el-option"), Ve = g("el-select"), ye = g("el-date-picker"), Pe = g("el-time-picker"), Be = g("el-row"), xe = g("el-form"), il = g("el-collapse-transition"), S = g("el-button"), fl = g("el-empty"), ae = g("el-table-column"), vl = g("el-descriptions-item"), bl = g("el-descriptions"), gl = g("el-button-group"), ml = g("el-table"), hl = g("el-pagination"), yl = g("el-cascader"), _l = g("plus"), Fl = g("el-icon"), Cl = g("el-upload"), El = g("el-scrollbar"), Se = g("el-card"), Dl = g("el-dialog"), oe = He("permission"), wl = He("loading");
      return p(), f(Se, {
        style: Hl([{ border: "0" }, L(Ke)])
      }, {
        default: n(() => [
          r(il, null, {
            default: n(() => [
              j(se("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: k
              }, [
                H(l.$slots, "search-form", {
                  editModel: y.value,
                  queryRecord: P,
                  CrudState: _
                }, void 0, !0),
                r(xe, {
                  model: y.value,
                  "label-width": v.labelWidth,
                  onKeyup: Ae(P, ["enter", "native"])
                }, {
                  default: n(() => [
                    r(Be, null, {
                      default: n(() => [
                        H(l.$slots, "search-form-top", { CrudState: _ }, void 0, !0),
                        (p(!0), M(U, null, Y(L($e), (e, s) => (p(), M(U, null, [
                          e.type === "el-input" ? (p(), f(F, {
                            key: 0,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(o, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-input-number" ? (p(), f(F, {
                            key: 1,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(X, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-select" ? (p(), f(F, {
                            key: 2,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(Ve, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, e.formProps), {
                                    default: n(() => [
                                      (p(!0), M(U, null, Y(e.formProps.options, (d) => (p(), f(C, {
                                        key: d.value,
                                        label: d.label,
                                        value: d.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && te(e).includes("range") ? (p(), f(F, {
                            key: 3,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 12
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: te(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && te(e) ? (p(), f(F, {
                            key: 4,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: te(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-time-picker" ? (p(), f(F, {
                            key: 5,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(Pe, B({
                                    style: { width: "100%" },
                                    modelValue: y.value[s],
                                    "onUpdate:modelValue": (d) => y.value[s] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    "is-range": e.range
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "is-range"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : $("", !0)
                        ], 64))), 256)),
                        H(l.$slots, "search-form-bottom", { CrudState: _ }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Al, v.IssearchForm]
              ])
            ]),
            _: 3
          }),
          se("div", {
            ref_key: "buttonAreaRef",
            ref: ce,
            class: "button_area"
          }, [
            j((p(), f(S, {
              type: "primary",
              icon: "plus",
              onClick: tl
            }, {
              default: n(() => [
                Il
              ]),
              _: 1
            })), [
              [oe, { permission: u.permission, access: [v.permission.add] }]
            ]),
            u.openMultipleSelection ? j((p(), f(S, {
              key: 0,
              disabled: ee.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: cl
            }, {
              default: n(() => [
                Kl
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [oe, { permission: u.permission, access: [v.permission.remove] }]
            ]) : $("", !0),
            H(l.$slots, "button-area", { CrudState: _ }, void 0, !0)
          ], 512),
          j((p(), f(ml, {
            ref_key: "tableRef",
            ref: Ce,
            data: fe.value,
            "row-key": u.rowKey,
            height: L(qe),
            onCellClick: We,
            onCellDblclick: Le,
            onRowContextmenu: je,
            onSelectionChange: Qe
          }, {
            empty: n(() => [
              r(fl, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: n(() => [
              u.openMultipleSelection ? (p(), f(ae, {
                key: 0,
                type: "selection",
                width: 44
              })) : $("", !0),
              u.expand ? (p(), f(ae, {
                key: 1,
                type: "expand",
                width: 55
              }, {
                default: n((e) => [
                  r(bl, {
                    column: u.expandColumn,
                    border: ""
                  }, {
                    default: n(() => [
                      (p(!0), M(U, null, Y(u.source.columns, (s, d) => (p(), M(U, { key: d }, [
                        s.hidden ? $("", !0) : (p(), f(vl, {
                          key: 0,
                          label: s.label
                        }, {
                          default: n(() => [
                            N(de(Ze(e, s, d)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1032, ["column"])
                ]),
                _: 1
              })) : $("", !0),
              u.openIndex ? (p(), f(ae, {
                key: 2,
                label: "###",
                width: 55,
                "show-overflow-tooltip": ""
              }, {
                default: n(({ row: e, column: s, $index: d }) => [
                  N(de(L(Te) + d), 1)
                ]),
                _: 1
              })) : $("", !0),
              (p(!0), M(U, null, Y(D.value.column, (e, s) => (p(), f(ae, B({
                key: s,
                align: e.align || "left"
              }, e.tableProps, {
                label: e.label,
                prop: s,
                "show-overflow-tooltip": ""
              }), ke({ _: 2 }, [
                e.columnSlot ? {
                  name: "default",
                  fn: n((d) => [
                    (p(), f(kl(e.columnSlot.is), Ml(Ul(Ge(e.columnSlot, d))), null, 16))
                  ])
                } : void 0
              ]), 1040, ["align", "label", "prop"]))), 128)),
              H(l.$slots, "default", {}, void 0, !0),
              r(ae, {
                align: v.menuAlign || "left",
                width: t.keyName ? v.menuWidth : v.menuWidth - 150
              }, {
                header: n(() => [
                  se("div", Tl, [
                    t.keyName ? (p(), f(o, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: y.value[t.keyName],
                      "onUpdate:modelValue": a[0] || (a[0] = (e) => y.value[t.keyName] = e),
                      placeholder: D.value.filter[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: Ae(P, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : $("", !0),
                    r(gl, null, {
                      default: n(() => [
                        r(S, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: P
                        }),
                        r(S, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: ol
                        }),
                        r(S, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: a[1] || (a[1] = (e) => v.IssearchForm = !v.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: n((e) => [
                  H(l.$slots, "menu-top", { scope: e }, void 0, !0),
                  j((p(), f(S, {
                    plain: "",
                    type: e.row.deleteFlag ? "danger" : "success",
                    onClick: (s) => dl(e.row)
                  }, {
                    default: n(() => [
                      N(de(e.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [oe, { permission: u.permission, access: [v.permission.deleteFlag] }]
                  ]),
                  j(r(S, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (s) => ul(e.row)
                  }, null, 8, ["onClick"]), [
                    [oe, { permission: u.permission, access: [v.permission.edit] }]
                  ]),
                  j(r(S, {
                    type: "danger",
                    icon: "delete",
                    onClick: (s) => pl(e.row)
                  }, null, 8, ["onClick"]), [
                    [oe, { permission: u.permission, access: [v.permission.delete] }]
                  ]),
                  H(l.$slots, "menu-bottom", { scope: e }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 8, ["data", "row-key", "height"])), [
            [wl, Z.value]
          ]),
          r(hl, {
            style: { "margin-top": "20px" },
            "hide-on-single-page": v.hideOnSinglePage,
            currentPage: V.current,
            "onUpdate:currentPage": a[2] || (a[2] = (e) => V.current = e),
            "page-size": V.pageSize,
            "onUpdate:page-size": a[3] || (a[3] = (e) => V.pageSize = e),
            "page-sizes": v.pageSizes,
            background: "",
            layout: u.PaginationLayout,
            total: V.total,
            onSizeChange: Xe,
            onCurrentChange: Ye
          }, null, 8, ["hide-on-single-page", "currentPage", "page-size", "page-sizes", "layout", "total"]),
          r(Dl, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: K.value,
            "onUpdate:modelValue": a[7] || (a[7] = (e) => K.value = e),
            title: J.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: v.dialogWidth,
            "destroy-on-close": "",
            fullscreen: u.fullscreen,
            "close-on-click-modal": u.destroyOnClosModal,
            onClosed: el
          }, ke({
            default: n(() => [
              r(Se, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: n(() => [
                  r(El, {
                    height: L(we),
                    "max-height": L(we)
                  }, {
                    default: n(() => [
                      H(l.$slots, "edit-form", {
                        editModel: h.value,
                        handleSubmit: re,
                        CrudState: _
                      }, void 0, !0),
                      r(xe, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: ie,
                        model: h.value,
                        "label-width": v.labelWidth
                      }, {
                        default: n(() => [
                          r(Be, null, {
                            default: n(() => [
                              H(l.$slots, "edit-form-top", {
                                editModel: h.value,
                                handleSubmit: re,
                                CrudState: _
                              }, void 0, !0),
                              (p(!0), M(U, null, Y(L(Ie), (e, s) => (p(), M(U, { key: s }, [
                                e.type === "el-input" ? (p(), f(F, {
                                  key: 0,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(o, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-input-number" ? (p(), f(F, {
                                  key: 1,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(X, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-select" ? (p(), f(F, {
                                  key: 2,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Ve, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), {
                                          default: n(() => [
                                            (p(!0), M(U, null, Y(e.formProps.options, (d) => (p(), f(C, {
                                              key: d.value,
                                              label: d.label,
                                              value: d.value
                                            }, null, 8, ["label", "value"]))), 128))
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-date-picker" ? (p(), f(F, {
                                  key: 3,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(ye, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-time-picker" ? (p(), f(F, {
                                  key: 4,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Pe, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          clearable: "",
                                          "start-placeholder": "\u8D77\u59CB",
                                          "range-separator": "\u81F3",
                                          "end-placeholder": "\u7ED3\u675F",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-cascader" ? (p(), f(F, {
                                  key: 5,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(yl, B({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (d) => h.value[s] = d,
                                          props: e.formProps.props,
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          "show-all-levels": !1,
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-upload" ? (p(), f(F, {
                                  key: 6,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Cl, B({
                                          style: { width: "100%" },
                                          ref_for: !0,
                                          ref: s + "UploadRef",
                                          action: ""
                                        }, Je(e.formProps)), {
                                          default: n(() => [
                                            e.formProps.listType !== "picture-card" ? (p(), f(S, {
                                              key: 0,
                                              type: "primary"
                                            }, {
                                              default: n(() => [
                                                N(de(e.formProps.butName || "\u9009\u62E9\u6587\u4EF6"), 1)
                                              ]),
                                              _: 2
                                            }, 1024)) : (p(), f(Fl, { key: 1 }, {
                                              default: n(() => [
                                                r(_l)
                                              ]),
                                              _: 1
                                            }))
                                          ]),
                                          _: 2
                                        }, 1040)
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : $("", !0)
                              ], 64))), 128)),
                              H(l.$slots, "edit-form-bottom", {
                                editModel: h.value,
                                handleSubmit: re,
                                CrudState: _
                              }, void 0, !0)
                            ]),
                            _: 3
                          })
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            Re.value ? {
              name: "footer",
              fn: n(() => [
                se("div", ql, [
                  H(l.$slots, "edit-form-footer", { CrudState: _ }, void 0, !0),
                  r(S, {
                    onClick: a[4] || (a[4] = (e) => K.value = !1)
                  }, {
                    default: n(() => [
                      Wl
                    ]),
                    _: 1
                  }),
                  r(S, {
                    type: "warning",
                    plain: "",
                    onClick: a[5] || (a[5] = (e) => nl(ie.value))
                  }, {
                    default: n(() => [
                      Ll
                    ]),
                    _: 1
                  }),
                  r(S, {
                    type: "primary",
                    loading: z.value,
                    onClick: a[6] || (a[6] = (e) => re(ie.value))
                  }, {
                    default: n(() => [
                      jl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Jl = (u, i) => {
  const m = u.__vccOpts || u;
  for (const [t, x] of i)
    m[t] = x;
  return m;
}, Fe = /* @__PURE__ */ Jl(Ql, [["__scopeId", "data-v-6bd4023b"]]), Gl = {
  mounted(u, i, m) {
    const t = i.value.permission, x = i.value.access;
    let E = !1;
    for (let k = 0; k < x.length; k++)
      if (t.includes(x[k])) {
        E = !0;
        break;
      } else
        E = !1;
    E || u.parentNode && u.parentNode.removeChild(u);
  }
};
Fe.install = (u) => {
  u.component("CrudEl", Fe), u.directive("permission", Gl);
};
const ea = (u, i) => {
  i ? (i.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Ue(i), u.use(Fe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  pe as DataMerger,
  R as DeepClone,
  Ue as InitSys,
  ea as createCrudEl,
  Q as hooksName,
  Ol as isObjEqual,
  zl as useHooks
};
