import CrudEl from './CrudEl'

import { hooksName, useHooks } from './CrudEl/hooks'

import { DeepClone, DataMerger, isObjEqual } from './CrudEl/components/Methods'
import { InitSys } from './CrudEl/components/SystemConfig'

const createCrudEl = (app: any, options: any) => {
    if (options) {
        if (!options.CrudRequest) console.error('请配置全局请求的主方法：CrudRequest')
        InitSys(options)
        app.use(CrudEl)
    } else {
        console.error('请初始化CrudEl配置项')
    }
}

export { createCrudEl, InitSys, DeepClone, DataMerger, isObjEqual, hooksName, useHooks }
